
SCSI_0	=	0xfd5000
SCSI_1	=	0xfd6000

|-------------------------------------------------------------------------
| _setdma()
|
| Parametrar vid anrop (efter link a6..):
|	0x8(a6)		Long
|	0xc(a6)		Long
|	0x10(a6)	Long
|	0x14(a6)
|	0x18(a6)	Long	HW adress till data port
|

	.globl	_setdma
_setdma:
	link	a6,#0x0
	moveml	#0x31c,-(sp)	| d6 d7 a3 a4 a5

	movl	0x10(a6),d7
	tstw	DS2917
	beqs	TS2918

	movb	#0xa,0x8301ff
	clrw	DS2917

TS2918:
	movl	0x18(a6),-(sp)
	bsr	_dmatab
	addql	#4,sp

	movl	d0,a5
	clrl	d0
	movb	(a5)+,d0
	movl	d0,d6

	movl	#0x312,-(sp)
	movl	d6,-(sp)
	jsr	lmul
	addql	#8,sp

	addl	#_dmadcb,d0
	movl	d0,a3
	tstl	d7
	bnes	TS2925
	orw	#0x3,(a3)
	bra	TS2936

TS2925:
	movl	d6,d0
	asll	#6,d0
	addl	#0x830100,d0
	movl	d0,a4
	movl	d7,0x2(a3)
	lea	0x12(a3),a0
	movl	0xc(a6),d0
	cmpl	a0,d0
	bnes	TS2926

	bset	#2,0x1(a3)
	addql	#1,a5
	clrl	d0
	movb	(a5)+,d0
	btst	#1,0x17(a6)
	beqs	TS2934

	moveq	#0x8,d1
	bras	TS2935

TS2934:
	movl	#0x88,d1

TS2935:
	orl	d1,d0
	movb	d0,0x5(a4)
	movl	0xc(a6),0x1c(a4)
	movw	0x10(a3),0x1a(a4)
	bras	TS2931

TS2926:
	movl	d7,-(sp)
	movl	0xc(a6),-(sp)
	movl	d6,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_pg_dma
	addw	#0x10,sp

	movl	d0,0xc(a6)
	movb	(a5)+,d0
	lsrl	d0,d7
	tstl	0xc(a6)
	beqs	TS2927
	movl	d7,d0
	andl	#0xffff0000,d0
	beqs	TS2929

TS2927:
	movl	d7,-(sp)
	movl	0xc(a6),-(sp)
	movl	#_dmadcb+3146,-(sp)
	jsr	_PRINT
	addw	#0xc,sp
	moveq	#0xffffffff,d0
	bras	TS2928

TS2929:
	clrl	d0
	movb	(a5)+,d0
	btst	#1,0x17(a6)
	beqs	TS2930
	clrl	d1
	bras	TS2933

TS2930:
	movl	#0x80,d1

TS2933:
	orl	d1,d0
	movb	d0,0x5(a4)
	movl	0xc(a6),0xc(a4)
	movw	d7,0xa(a4)
	bras	TS2931

TS2932:
	clrl	d0
	movb	(a5),d0
	addl	a4,d0
	movl	d0,a0
	movb	0x1(a5),(a0)
	addql	#2,a5

TS2931:
	tstb	(a5)
	bnes	TS2932
	movl	0x18(a6),0x14(a4)
	movb	d6,0x29(a4)
	movb	d6,0x31(a4)
	movb	d6,0x39(a4)
	movb	(a4),(a4)
	movb	#0x80,0x7(a4)
	bset	#0,0x1(a3)

TS2936:
	clrl	d0

TS2928:
	moveml	(sp)+,#0x38c0	| d6 d7 a3 a4 a5
	unlk	a6
	rts

|-------------------------------------------------------------------------
| _clrdma()
|

	.globl	_clrdma
_clrdma:
	link	a6,#0x0
	moveml	#0x13c,-(sp)	| d7 a2 a3 a4 a5

	movl	0x8(a6),-(sp)
	bsr	_dmatab
	addql	#4,sp

	movl	d0,a4
	clrl	d0
	movb	(a4),d0
	mulu	#0x312,d0
	addl	#_dmadcb,d0
	movl	d0,a5
	clrl	d0
	movb	(a4)+,d0
	lsll	#6,d0
	addl	#0x830100,d0
	movl	d0,a3
	movb	#0x10,0x7(a3)
	btst	#1,0x1(a5)
	beqs	TS2946
	clrl	d7
	bras	TS2952

TS2946:
	btst	#2,0x1(a5)
	beqs	TS2947
	clrl	d7
	lea	0x12(a5),a0
	movl	a0,a2
	bras	TS2949

TS2950:
	addql	#4,a2
	clrl	d0
	movw	(a2)+,d0
	addl	d0,d7

TS2949:
	cmpl	0x1c(a3),a2
	bcss	TS2950
	cmpl	0x1c(a3),a2
	bnes	TS2951
	clrl	d0
	movw	0xa(a3),d0
	subl	d0,d7

TS2951:
	movb	(a4)+,d0
	lsll	d0,d7
	bras	TS2952

TS2947:
	clrl	d0
	movw	0xa(a3),d0
	clrl	d1
	movb	(a4)+,d1
	lsll	d1,d0
	movl	0x2(a5),d1
	subl	d0,d1
	movl	d1,d7

TS2952:
	andw	#0xfff8,(a5)
	tstl	0x6(a5)
	beqs	TS2948
	movl	0xa(a5),-(sp)
	movl	0x6(a5),a0
	jsr	(a0)
	addql	#4,sp
	clrl	0x6(a5)

TS2948:
	movl	d7,d0

	moveml	(sp)+,#0x3c80	| d7 a2 a3 a4 a5
	unlk	a6
	rts


|-------------------------------------------------------------------------
| _waitdma()
|

	.globl	_waitdma
_waitdma:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5

	movl	0x8(a6),-(sp)
	bsrs	_dmatab
	addql	#4,sp

	movl	d0,a4
	clrl	d0
	movb	(a4),d0
	mulu	#0x312,d0
	addl	#_dmadcb,d0
	movl	d0,a5
	btst	#0,0x1(a5)
	bnes	TS3273
	clrl	d0

TS3275:
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts


|-------------------------------------------------------------------------
| _dmatab()
|
| Parametrar vid anrop (efter link a6..):
|	0x8(a6)		Long	HW adress
|

_dmatab:
	link	a6,#0x0
	movl	a5,-(sp)

	movl	0x8(a6),d0		| H{mta HW adress

	cmpl	#SCSI_0,d0		| 0xfd5000, SCSI 0 ?
	beqs	TS2919			| Ja, hoppa

	cmpl	#SCSI_1,d0		| 0xfd6000, SCSI 1 ?
	beqs	TS2922			| Ja, hoppa

	cmpl	#0xfdb047,d0		| Floppy ?
	beqs	TS2923			| Ja, hoppa

	| Tillh|r adressen Databoard bussen ?
	cmpl	#0xfe0001,d0
	bcss	TS2924			| Nej, skriv ut fel och avsluta
	cmpl	#0xfff801,d0
	bhis	TS2924			| Nej, skriv ut fel och avsluta

	movl	#_dma_4680,a5		| Ja, 


	| Avsluta rutinen med en pekare till dma data f|r device:n
TS2920:
	movl	a5,d0
	bras	TS2921			| Avsluta rutinen


TS3273:
	tstl	0x6(a5)
	beqs	TS3274

	movl	#_dmadcb+3178,-(sp)
	jsr	_panic
	addql	#4,sp

TS3274:
	movl	0xc(a6),0x6(a5)
	movl	0x10(a6),0xa(a5)
	moveq	#0xffffffff,d0
	bras	TS3275


	| Adressen tillh|r floppy:n
TS2923:
	movl	#_dma_fpy,a5
	bras	TS2920			| Avsluta med _dma_fpy som resultat


	| Adressen tillh|r SCSI 0
TS2919:
	movl	#_dma_si0,a5
	bras	TS2920			| Avsluta med _dma_si0 som resultat


	| Adressen tillh|r SCSI 1
TS2922:
	movl	#_dma_si1,a5
	bras	TS2920			| Avsluta med _dma_si1 som resultat

	
	| Skriv ut felmeddelande och avsluta rutinen
TS2924:
	movl	0x8(a6),-(sp)
	movl	#_dmadcb+3211,-(sp)
	jsr	_PRINT
	addql	#8,sp

	clrl	d0			| Avsluta med v{rdet 0

TS2921:
	movl	(sp)+,a5
	unlk	a6
	rts


|-------------------------------------------------------------------------
| _dmachain()
|

	.globl	_dmachain
_dmachain:
	link	a6,#0x0
	moveml	#0x73c,-(sp)	| d5 d6 d7 a2 a3 a4 a5

	movl	0x8(a6),a5

	movl	0xc(a6),-(sp)
	bsr	_dmatab
	addql	#4,sp

	movl	d0,a3
	clrl	d0
	movb	(a3)+,d0
	mulu	#0x312,d0
	addl	#_dmadcb,d0
	movl	d0,a4
	btst	#0,0x1(a4)
	beqs	TS2980
	clrl	d0
	bras	TS2988

TS2980:
	clrl	d0
	movb	(a3)+,d0
	movl	d0,d5
	lea	0x12(a4),a0
	movl	a0,a3
	clrl	0xe(a4)
	bras	TS2981

TS2982:
	movl	0x1e(a5),a2
	movl	0x22(a5),d0
	lsrl	d5,d0
	movl	d0,d6
	bras	TS2983

TS2984:
	tstl	d6
	beqs	TS2985
	cmpl	#0x10000,d6
	bges	TS2986
	movl	d6,d0
	bras	TS2987

TS2986:
	movl	#0xffff,d0

TS2987:
	movl	d0,d7
	movl	a2,(a3)+
	movw	d7,(a3)+
	movl	d7,d0
	asll	d5,d0
	addl	d0,a2
	subl	d7,d6
	addql	#1,0xe(a4)

TS2983:
	cmpl	#0x80,0xe(a4)
	blts	TS2984

TS2985:
	movl	0x12(a5),a5

TS2981:
	movl	a5,d0
	bnes	TS2982
	lea	0x12(a4),a0
	movl	a0,d0

TS2988:
	moveml	(sp)+,#0x3ce0	| d5 d6 d7 a2 a3 a4 a5
	unlk	a6
	rts
